/*
 * Userspace Semaphores
 */
#ifndef	_USERSEM_H
#define	_USERSEM_H

/* You should never touch this structure directly! */
struct usersem
{
	int count;
	unsigned int num_sleepers;
};

/* Prepare to use usersemaphores (returns fd as per open). */
int usem_open(void);
void usem_close(int usem_fd);

void usem_init(struct usersem *sem);
/* Down and up operations */
int usem_down(struct usersem *sem, int usem_fd);
int usem_up(struct usersem *sem, int usem_fd);
#endif /* _USERSEM_H */
